'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var OffsetScroll = function (_React$Component) {
  _inherits(OffsetScroll, _React$Component);

  function OffsetScroll(props) {
    _classCallCheck(this, OffsetScroll);

    var _this = _possibleConstructorReturn(this, (OffsetScroll.__proto__ || Object.getPrototypeOf(OffsetScroll)).call(this, props));

    _this.state = {
      scrolled: false
    };
    _this.initRef = _this.initRef.bind(_this);
    _this.onScroll = _this.onScroll.bind(_this);
    return _this;
  }

  _createClass(OffsetScroll, [{
    key: 'initRef',
    value: function initRef(node) {
      if (node) {
        this.containerNode = node;
        this.calculateScrollTop(this.props);
      }
    }
  }, {
    key: 'onScroll',
    value: function onScroll(e) {
      this.setState({ scrolled: true });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.offset !== this.props.offset || !this.state.scrolled) {
        this.calculateScrollTop(nextProps);
      }
    }
  }, {
    key: 'calculateScrollTop',
    value: function calculateScrollTop(props) {
      var top = (props.offset || 0) * props.elementHeight;
      this.containerNode.scrollTop = top;
    }
  }, {
    key: 'render',
    value: function render() {
      var cls = ['offset-scroll'];
      if (this.props.className) cls.push(this.props.className);
      return _react2.default.createElement(
        'div',
        { className: cls.join(' '),
          style: {
            overflow: 'auto'
          },
          ref: this.initRef,
          onScroll: this.onScroll },
        this.props.children
      );
    }
  }]);

  return OffsetScroll;
}(_react2.default.Component);

OffsetScroll.propTypes = {
  elementHeight: _propTypes2.default.number.isRequired,
  offset: _propTypes2.default.number.isRequired,
  className: _propTypes2.default.string
};
exports.default = OffsetScroll;